#include "extapi.h"
#include "zstr.h"
extern CExtAPI theAPI;

CzStr::CzStr(void) {
	Create(0);
}

CzStr::~CzStr(void) {
}

bool CzStr::Create(const char* lpVarName){
	return CzVar::Create(VarID_string, lpVarName);
}

const char* CzStr::GetText() {
	if(!m_hVar)	return 0;

	return theAPI.str_GetText(m_hVar);
}
bool CzStr::SetText(const char* lpTextStr) {
	if(!m_hVar)	return false;

	return theAPI.str_SetText(m_hVar, lpTextStr);
}

int CzStr::GetLength() { return (int)strlen(GetText()); }
bool CzStr::IsStr(const char* lpText) { return !Compare(lpText); }
int CzStr::Compare(const char* lpText) { return strcmp(GetText(), lpText); }
int CzStr::CompareNoCase(const char* lpText) {
	int len = GetLength();
	int len2 = strlen(lpText);

	if(len!=len2) {
		return 1; // not returning normal strcmp value; just 1 and 0
	}

	if(len) {
		
		for(int i=0; i<len; i++) {
			int c = GetAt(i);
			int c2 = lpText[i];

			if(isalpha(c)) {
				if(tolower(c) != tolower(c2)) {
					return 1; // not returning normal strcmp value; just 1 and 0
				}
			}
		}
	}

	// debugging
	//theAPI.ReportError(pBuf);
	//theAPI.ReportError(lpText);

	return 0; // not returning normal strcmp value; just 1 and 0
}

char CzStr::GetAt(int index) {
	if(index<0 || index>=GetLength())
		return 0;

	return (GetText()[index]);
}

int CzStr::Find(const char* lpText, int StartPos) {

	if(!lpText) {
		return -1;
	}

	int slen = (int)strlen(lpText);
	if(!slen) {
		return -1;
	}

	int thislen = GetLength();

	if(StartPos<0 || StartPos>=thislen) {
		return -1;
	}

	for(int p=StartPos; p<thislen; p++) {
		bool IsOK = true;
		for(int q=0; q<slen && p+q<thislen && IsOK; q++) {
			if(lpText[q]!=GetAt(p+q)) {
				IsOK = false;
			}
		}
		if(IsOK) {
			return p;
		}
	}

	return -1;
}

const char* CzStr::Append(const char* lpNewText) {
	if(!lpNewText)	return GetText();

	long buflen = GetLength()+(long)strlen(lpNewText)+1;
	if(buflen<1)
		return 0;

	char* pBuf = (char*)malloc(buflen);
	if(!pBuf)	return 0;

	sprintf_s(pBuf, buflen, "%s%s", GetText(), lpNewText);
	SetText(pBuf);

	free(pBuf);
	return GetText();
}
const char* CzStr::AppendChar(char c) {
	char c2[2];
	c2[0]=c;
	c2[1]=0;
	return Append(c2);
}